﻿/*
Draggable cone
*/

package {
	import flash.events.*;
	import flash.display.*;
	
	public class DraggableCone extends MovieClip {

		private var id:Number;

		public function DraggableCone(isTop:Boolean, p_id:Number) {
			var img:Sprite = isTop ? new ConeViewTop() : new ConeViewSide();
			addChild(img);
			id = p_id;

			addEventListener(MouseEvent.MOUSE_DOWN, startToDrag);
			useHandCursor = true;
			buttonMode = true;
			addEventListener(MouseEvent.CLICK, function() {});
		}

		private function startToDrag(e:MouseEvent):void {
			startDrag();
			parent.setChildIndex(this, parent.numChildren - 1);
			addEventListener(MouseEvent.MOUSE_UP, stopToDrag);
			addEventListener(MouseEvent.MOUSE_MOVE, mouseMove);
		}
		private function stopToDrag(e:MouseEvent):void {
			stopDrag();
			removeEventListener(MouseEvent.MOUSE_UP, stopToDrag);
			removeEventListener(MouseEvent.MOUSE_MOVE, mouseMove);
		}
		private function mouseMove(e:MouseEvent):void {
			Viewport(parent).updateCone(id);
			parent.setChildIndex(this, parent.numChildren - 1);
			e.updateAfterEvent();
		}
	}
}
